
#ifndef _PROCESSORSYSTEMRRR_
#define _PROCESSORSYSTEMRRR_

#include <stdio.h>
#include <sys/time.h>

#include "asim/provides/low_level_platform_interface.h"
#include "asim/provides/funcp_simulated_memory.h"
#include "asim/provides/rrr.h"



typedef class PROCESSORSYSTEMRRR_SERVER_CLASS* PROCESSORSYSTEMRRR_SERVER;
class PROCESSORSYSTEMRRR_SERVER_CLASS: public RRR_SERVER_CLASS, public PLATFORMS_MODULE_CLASS
{
  private:
    // self-instantiation
    static PROCESSORSYSTEMRRR_SERVER_CLASS instance;
    FUNCP_SIMULATED_MEMORY_CLASS *memory;   

 
    // server stub
    RRR_SERVER_STUB serverStub;

    int count;    

  public:
    PROCESSORSYSTEMRRR_SERVER_CLASS();
    ~PROCESSORSYSTEMRRR_SERVER_CLASS();

    // static methods
    static PROCESSORSYSTEMRRR_SERVER GetInstance() { return &instance; }

    // required RRR methods
    void Init(PLATFORMS_MODULE);
    void Uninit();
    void Cleanup();

    //
    // RRR service methods
    //

   UINT32 MemoryRequestLoad  (UINT32 address);
   void   MemoryRequestStore (UINT32 address, UINT32 data);
};



// include server stub
#include "asim/rrr/server_stub_PROCESSORSYSTEMRRR.h"

#endif
